<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/hlo_json/propagate/graph_propagate.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>graph_propagate.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
<span id="634">634</span>
<span id="635">635</span>
<span id="636">636</span>
<span id="637">637</span>
<span id="638">638</span>
<span id="639">639</span>
<span id="640">640</span>
<span id="641">641</span>
<span id="642">642</span>
<span id="643">643</span>
<span id="644">644</span>
<span id="645">645</span>
<span id="646">646</span>
<span id="647">647</span>
<span id="648">648</span>
<span id="649">649</span>
<span id="650">650</span>
<span id="651">651</span>
<span id="652">652</span>
<span id="653">653</span>
<span id="654">654</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">hlo_ast</span>::{<span class="ident">HLOFunction</span>, <span class="ident">Param</span>};
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">propagate</span>::<span class="ident">vargraph</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">log</span>::<span class="ident">debug</span>;
<span class="kw">use</span> <span class="ident">petgraph</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">rayon</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">collections</span>::{<span class="ident">BTreeMap</span>, <span class="ident">BTreeSet</span>, <span class="ident">HashSet</span>, <span class="ident">VecDeque</span>};
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">error</span>::<span class="ident">Error</span>;

<span class="comment">// const VERBOSE_THRESHOLD: usize = 1000;</span>
<span class="comment">// const DFS_RETURN_THRESHOLD: usize = 9000;</span>

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Eq</span>, <span class="ident">PartialEq</span>, <span class="ident">Hash</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">State</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">visited_node</span>: <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span>,
    <span class="ident">last_node</span>: <span class="ident">NodeIndex</span>,
    <span class="ident">visited_inst</span>: <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="ident">i32</span>, <span class="ident">i32</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">State</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">from_node</span>(<span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">dim</span>: <span class="ident">i8</span>, <span class="ident">index</span>: <span class="ident">NodeIndex</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">vn</span>: <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">BTreeMap</span>::<span class="ident">new</span>();
        <span class="ident">vn</span>.<span class="ident">insert</span>(<span class="ident">name</span>, <span class="ident">dim</span>);
        <span class="ident">State</span> {
            <span class="ident">visited_node</span>: <span class="ident">vn</span>,
            <span class="ident">last_node</span>: <span class="ident">index</span>,
            <span class="ident">visited_inst</span>: <span class="ident">BTreeMap</span>::<span class="ident">new</span>(),
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">add_node</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">dim</span>: <span class="ident">i8</span>, <span class="ident">index</span>: <span class="ident">NodeIndex</span>) {
        <span class="self">self</span>.<span class="ident">visited_node</span>.<span class="ident">insert</span>(<span class="ident">name</span>, <span class="ident">dim</span>);
        <span class="self">self</span>.<span class="ident">last_node</span> <span class="op">=</span> <span class="ident">index</span>;
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">add_edge</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">inst_id</span>: <span class="ident">i32</span>, <span class="ident">edge_color</span>: <span class="ident">i32</span>) {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">visited_inst</span>.<span class="ident">contains_key</span>(<span class="kw-2">&amp;</span><span class="ident">inst_id</span>) {
            <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="self">self</span>.<span class="ident">visited_inst</span>[<span class="kw-2">&amp;</span><span class="ident">inst_id</span>], <span class="ident">edge_color</span>);
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">visited_inst</span>.<span class="ident">insert</span>(<span class="ident">inst_id</span>, <span class="ident">edge_color</span>);
        }
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">VarGraph3D</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">intersect_with</span>(
        <span class="ident">a</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">b</span>: <span class="kw-2">&amp;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="kw">for</span> (<span class="ident">k</span>, <span class="ident">v</span>) <span class="kw">in</span> <span class="ident">b</span> {
            <span class="kw">if</span> <span class="ident">a</span>.<span class="ident">contains_key</span>(<span class="ident">k</span>) {
                <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;map: adding {:?} to ({}, {:?})&quot;</span>, <span class="ident">v</span>, <span class="ident">k</span>, <span class="ident">a</span>[<span class="ident">k</span>]);
                <span class="kw">let</span> <span class="ident">new_set</span>: <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">a</span>[<span class="ident">k</span>].<span class="ident">intersection</span>(<span class="kw-2">&amp;</span><span class="ident">v</span>).<span class="ident">cloned</span>().<span class="ident">collect</span>();
                <span class="kw-2">*</span><span class="ident">a</span>.<span class="ident">get_mut</span>(<span class="ident">k</span>).<span class="ident">unwrap</span>() <span class="op">=</span> <span class="ident">new_set</span>;
                <span class="kw">if</span> <span class="ident">a</span>[<span class="ident">k</span>].<span class="ident">len</span>() <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
                    <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;set intersection results in empty&quot;</span>);
                    <span class="kw">return</span> <span class="bool-val">false</span>;
                }
                <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;map: now {} -&gt; {:?}&quot;</span>, <span class="ident">k</span>, <span class="ident">a</span>[<span class="ident">k</span>]);
            } <span class="kw">else</span> {
                <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;map: new {} -&gt; {:?}&quot;</span>, <span class="ident">k</span>, <span class="ident">v</span>);
                <span class="ident">a</span>.<span class="ident">insert</span>(<span class="ident">k</span>, <span class="ident">v</span>.<span class="ident">clone</span>());
            }
        }

        <span class="bool-val">true</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">propagate</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">HLOFunction</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">return_var</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">f</span>.<span class="ident">body</span>[<span class="ident">f</span>.<span class="ident">body</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>].<span class="ident">var_name</span>;
        <span class="kw">let</span> <span class="ident">result</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">propagate_remt</span>(<span class="number">0</span>, <span class="kw-2">&amp;</span><span class="ident">BTreeMap</span>::<span class="ident">new</span>(), <span class="kw-2">&amp;</span><span class="ident">f</span>.<span class="ident">params</span>, <span class="prelude-val">Some</span>(<span class="ident">return_var</span>))<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">result</span>)
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">propagate_remt</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">index</span>: <span class="ident">usize</span>,
        <span class="ident">m_constraits</span>: <span class="kw-2">&amp;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">params</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Param</span><span class="op">&gt;</span>,
        <span class="ident">return_var</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span><span class="op">&gt;</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="ident">params</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">300</span> {
            <span class="macro">println</span><span class="macro">!</span>(
                <span class="string">&quot;remt {} @ index {}, m.len() = {}&quot;</span>,
                <span class="ident">params</span>[<span class="ident">index</span>].<span class="ident">name</span>.<span class="ident">as_str</span>(),
                <span class="ident">index</span>,
                <span class="ident">m_constraits</span>.<span class="ident">len</span>(),
            );
        }
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">ret</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec</span><span class="macro">!</span>[];

        <span class="comment">// construct the solution space for current index</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">dim_list</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span>;
        <span class="kw">let</span> <span class="ident">param_name</span> <span class="op">=</span> <span class="ident">params</span>[<span class="ident">index</span>].<span class="ident">name</span>.<span class="ident">as_str</span>();
        <span class="kw">if</span> <span class="ident">m_constraits</span>.<span class="ident">contains_key</span>(<span class="ident">param_name</span>) {
            <span class="macro">debug</span><span class="macro">!</span>(
                <span class="string">&quot;range contraints: {} -&gt; {}&quot;</span>,
                <span class="ident">params</span>[<span class="ident">index</span>]
                    .<span class="ident">param_type</span>
                    .<span class="ident">dimensions</span>
                    .<span class="ident">as_ref</span>()
                    .<span class="ident">unwrap_or</span>(<span class="kw-2">&amp;</span><span class="macro">vec</span><span class="macro">!</span>[])
                    .<span class="ident">len</span>()
                    <span class="op">+</span> <span class="number">1</span>,
                <span class="ident">m_constraits</span>[<span class="ident">param_name</span>].<span class="ident">len</span>()
            );
            <span class="ident">dim_list</span> <span class="op">=</span> <span class="ident">m_constraits</span>[<span class="ident">param_name</span>].<span class="ident">iter</span>().<span class="ident">cloned</span>().<span class="ident">collect</span>();
        } <span class="kw">else</span> {
            <span class="ident">dim_list</span> <span class="op">=</span> (<span class="number">0</span>..<span class="ident">params</span>[<span class="ident">index</span>]
                .<span class="ident">param_type</span>
                .<span class="ident">dimensions</span>
                .<span class="ident">as_ref</span>()
                .<span class="ident">unwrap_or</span>(<span class="kw-2">&amp;</span><span class="macro">vec</span><span class="macro">!</span>[])
                .<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">i8</span>)
                .<span class="ident">collect</span>();
            <span class="kw">if</span> <span class="op">!</span><span class="ident">dim_list</span>.<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="op">-</span><span class="number">1i8</span>) {
                <span class="ident">dim_list</span>.<span class="ident">push</span>(<span class="op">-</span><span class="number">1i8</span>);
            }
        }

        <span class="kw">if</span> <span class="ident">index</span> <span class="op">+</span> <span class="number">1</span> <span class="op">=</span><span class="op">=</span> <span class="ident">params</span>.<span class="ident">len</span>() {
            <span class="ident">ret</span>.<span class="ident">par_extend</span>(
                <span class="ident">dim_list</span>
                    .<span class="ident">par_iter</span>()
                    .<span class="ident">map</span>(<span class="op">|</span><span class="ident">d</span><span class="op">|</span> {
                        <span class="kw">let</span> <span class="ident">node</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">get_node_id</span>(<span class="ident">param_name</span>, <span class="kw-2">*</span><span class="ident">d</span>);
                        <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">is_none</span>() {
                            <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;failed to get node_id for ({},{})&quot;</span>, <span class="ident">param_name</span>, <span class="ident">d</span>);
                            <span class="kw">return</span> <span class="prelude-val">None</span>;
                        }
                        <span class="kw">let</span> <span class="ident">node_id</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">unwrap</span>();
                        <span class="kw">let</span> <span class="ident">result</span> <span class="op">=</span> <span class="self">self</span>
                            .<span class="ident">propagate_bfs</span>(<span class="ident">node_id</span>, <span class="ident">m_constraits</span>, <span class="ident">params</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">300</span>)
                            .<span class="ident">unwrap</span>();
                        <span class="kw">if</span> <span class="ident">params</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">300</span> {
                            <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;result += {:?}&quot;</span>, <span class="ident">result</span>);
                        }
                        <span class="kw">return</span> <span class="prelude-val">Some</span>(<span class="ident">result</span>);
                        <span class="comment">// ret.push(result);</span>
                    })
                    .<span class="ident">filter</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="ident">is_some</span>())
                    .<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="ident">unwrap</span>()),
            );

            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">ret</span>);
        }

        <span class="ident">ret</span>.<span class="ident">par_extend</span>(
            <span class="ident">dim_list</span>
                .<span class="ident">par_iter</span>()
                .<span class="ident">flat_map</span>(<span class="op">|</span><span class="ident">d</span><span class="op">|</span> {
                    <span class="kw">let</span> <span class="ident">node</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">get_node_id</span>(<span class="ident">param_name</span>, <span class="kw-2">*</span><span class="ident">d</span>);
                    <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">is_none</span>() {
                        <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;[remt]\t failed to get node_id for ({},{})&quot;</span>, <span class="ident">param_name</span>, <span class="ident">d</span>);
                        <span class="kw">return</span> <span class="macro">vec</span><span class="macro">!</span>[];
                    }
                    <span class="kw">let</span> <span class="ident">node_id</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">unwrap</span>();
                    <span class="kw">let</span> <span class="ident">m</span> <span class="op">=</span> <span class="self">self</span>
                        .<span class="ident">propagate_bfs</span>(<span class="ident">node_id</span>, <span class="ident">m_constraits</span>, <span class="ident">params</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">300</span>)
                        .<span class="ident">unwrap</span>();

                    <span class="kw">if</span> <span class="ident">params</span>.<span class="ident">len</span>() <span class="op">&gt;</span> <span class="number">300</span> {
                        <span class="kw">let</span> <span class="ident">mc</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">clone</span>();
                        <span class="kw">for</span> <span class="ident">p</span> <span class="kw">in</span> <span class="ident">params</span>.<span class="ident">iter</span>() {
                            <span class="kw">if</span> <span class="ident">mc</span>.<span class="ident">contains_key</span>(<span class="ident">p</span>.<span class="ident">name</span>.<span class="ident">as_str</span>()) {
                                <span class="macro">print</span><span class="macro">!</span>(<span class="string">&quot;\&quot;{}\&quot;: {:?}, &quot;</span>, <span class="ident">p</span>.<span class="ident">name</span>.<span class="ident">as_str</span>(), <span class="ident">mc</span>[<span class="ident">p</span>.<span class="ident">name</span>.<span class="ident">as_str</span>()]);
                            }
                        }
                        <span class="macro">println</span><span class="macro">!</span>(<span class="string">&quot;&quot;</span>);
                    }
                    <span class="kw">let</span> <span class="ident">sub_res</span> <span class="op">=</span> <span class="self">self</span>
                        .<span class="ident">propagate_remt</span>(<span class="ident">index</span> <span class="op">+</span> <span class="number">1</span>, <span class="kw-2">&amp;</span><span class="ident">m</span>, <span class="ident">params</span>, <span class="ident">return_var</span>)
                        .<span class="ident">unwrap</span>();
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">sub_ret</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="macro">vec</span><span class="macro">!</span>[];
                    <span class="kw">for</span> <span class="ident">ssr</span> <span class="kw">in</span> <span class="ident">sub_res</span> {
                        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">m_copied</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">clone</span>();
                        <span class="kw">let</span> <span class="ident">suc</span> <span class="op">=</span> <span class="self">Self</span>::<span class="ident">intersect_with</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">m_copied</span>, <span class="kw-2">&amp;</span><span class="ident">ssr</span>);
                        <span class="kw">if</span> <span class="ident">suc</span> {
                            <span class="ident">sub_ret</span>.<span class="ident">push</span>(<span class="ident">m_copied</span>);
                        }
                    }
                    <span class="kw">return</span> <span class="ident">sub_ret</span>;
                })
                .<span class="ident">collect</span>::<span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>(),
        );

        <span class="prelude-val">Ok</span>(<span class="ident">ret</span>)
    }

    <span class="comment">// pub fn propagate_re(</span>
    <span class="comment">//     &amp;mut self,</span>
    <span class="comment">//     index: usize,</span>
    <span class="comment">//     m_constraits: &amp;BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;,</span>
    <span class="comment">//     params: &amp;&#39;a Vec&lt;Param&gt;,</span>
    <span class="comment">//     return_var: Option&lt;&amp;&#39;a str&gt;,</span>
    <span class="comment">// ) -&gt; Result&lt;Vec&lt;BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;&gt;, Box&lt;dyn Error&gt;&gt; {</span>
    <span class="comment">//     if params.len() &gt; 300 {</span>
    <span class="comment">//         println!(</span>
    <span class="comment">//             &quot;re {} @ index {}, m.len() = {}&quot;,</span>
    <span class="comment">//             params[index].name.as_str(),</span>
    <span class="comment">//             index,</span>
    <span class="comment">//             m_constraits.len(),</span>
    <span class="comment">//         );</span>
    <span class="comment">//     }</span>
    <span class="comment">//     let mut ret: Vec&lt;BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;&gt; = vec![];</span>
    <span class="comment">//</span>
    <span class="comment">//     let bfs_switch = true;</span>
    <span class="comment">//</span>
    <span class="comment">//     // construct the solution space for current index</span>
    <span class="comment">//     let mut dim_list: Vec&lt;i8&gt;;</span>
    <span class="comment">//     let param_name = params[index].name.as_str();</span>
    <span class="comment">//     if m_constraits.contains_key(param_name) {</span>
    <span class="comment">//         debug!(</span>
    <span class="comment">//             &quot;range contraints: {} -&gt; {}&quot;,</span>
    <span class="comment">//             params[index]</span>
    <span class="comment">//                 .param_type</span>
    <span class="comment">//                 .dimensions</span>
    <span class="comment">//                 .as_ref()</span>
    <span class="comment">//                 .unwrap_or(&amp;vec![])</span>
    <span class="comment">//                 .len()</span>
    <span class="comment">//                 + 1,</span>
    <span class="comment">//             m_constraits[param_name].len()</span>
    <span class="comment">//         );</span>
    <span class="comment">//         dim_list = m_constraits[param_name].iter().cloned().collect();</span>
    <span class="comment">//     } else {</span>
    <span class="comment">//         dim_list = (0..params[index]</span>
    <span class="comment">//             .param_type</span>
    <span class="comment">//             .dimensions</span>
    <span class="comment">//             .as_ref()</span>
    <span class="comment">//             .unwrap_or(&amp;vec![])</span>
    <span class="comment">//             .len() as i8)</span>
    <span class="comment">//             .collect();</span>
    <span class="comment">//         if !dim_list.contains(&amp;-1i8) {</span>
    <span class="comment">//             dim_list.push(-1i8);</span>
    <span class="comment">//         }</span>
    <span class="comment">//     }</span>
    <span class="comment">//</span>
    <span class="comment">//     if index + 1 == params.len() {</span>
    <span class="comment">//         for d in dim_list.iter() {</span>
    <span class="comment">//             let node = self.get_node_id(param_name, *d);</span>
    <span class="comment">//             if node.is_none() {</span>
    <span class="comment">//                 println!(&quot;failed to get node_id for ({},{})&quot;, param_name, d);</span>
    <span class="comment">//                 continue;</span>
    <span class="comment">//             }</span>
    <span class="comment">//             let node_id = node.unwrap();</span>
    <span class="comment">//             if bfs_switch {</span>
    <span class="comment">//                 let result = self.propagate_bfs(node_id, m_constraits, params.len() &gt; 300)?;</span>
    <span class="comment">//                 if params.len() &gt; 300 {</span>
    <span class="comment">//                     println!(&quot;result += {:?}&quot;, result);</span>
    <span class="comment">//                 }</span>
    <span class="comment">//                 ret.push(result);</span>
    <span class="comment">//             } else {</span>
    <span class="comment">//                 self.visited = RefCell::new(HashSet::new());</span>
    <span class="comment">//                 let result = self.propagate_dfs(</span>
    <span class="comment">//                     node_id,</span>
    <span class="comment">//                     BTreeMap::new(),</span>
    <span class="comment">//                     HashMap::new(),</span>
    <span class="comment">//                     HashMap::new(),</span>
    <span class="comment">//                     m_constraits,</span>
    <span class="comment">//                     vec![],</span>
    <span class="comment">//                     params.len() &gt; VERBOSE_THRESHOLD, // true if</span>
    <span class="comment">//                 )?;</span>
    <span class="comment">//                 if let Some(m) = result {</span>
    <span class="comment">//                     if params.len() &gt; 300 {</span>
    <span class="comment">//                         println!(&quot;result += {:?}&quot;, m);</span>
    <span class="comment">//                     }</span>
    <span class="comment">//</span>
    <span class="comment">//                     ret.push(m);</span>
    <span class="comment">//                 }</span>
    <span class="comment">//             }</span>
    <span class="comment">//         }</span>
    <span class="comment">//         return Ok(ret);</span>
    <span class="comment">//     }</span>
    <span class="comment">//</span>
    <span class="comment">//     for d in dim_list.iter() {</span>
    <span class="comment">//         let node = self.get_node_id(param_name, *d);</span>
    <span class="comment">//         if node.is_none() {</span>
    <span class="comment">//             println!(&quot;failed to get node_id for ({},{})&quot;, param_name, d);</span>
    <span class="comment">//             continue;</span>
    <span class="comment">//         }</span>
    <span class="comment">//         let node_id = node.unwrap();</span>
    <span class="comment">//         let mut m: BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt; = BTreeMap::new();</span>
    <span class="comment">//         if bfs_switch {</span>
    <span class="comment">//             m = self.propagate_bfs(node_id, m_constraits, params.len() &gt; 300)?;</span>
    <span class="comment">//         } else {</span>
    <span class="comment">//             self.visited = RefCell::new(HashSet::new());</span>
    <span class="comment">//             if params.len() &gt; 300 {</span>
    <span class="comment">//                 println!(&quot;dfs {} , {}&quot;, param_name, *d);</span>
    <span class="comment">//             }</span>
    <span class="comment">//</span>
    <span class="comment">//             let result = self.propagate_dfs(</span>
    <span class="comment">//                 node_id,</span>
    <span class="comment">//                 BTreeMap::new(),</span>
    <span class="comment">//                 HashMap::new(),</span>
    <span class="comment">//                 HashMap::new(),</span>
    <span class="comment">//                 m_constraits,</span>
    <span class="comment">//                 vec![],</span>
    <span class="comment">//                 params.len() &gt; VERBOSE_THRESHOLD, // true if</span>
    <span class="comment">//             )?;</span>
    <span class="comment">//             if result.is_none() {</span>
    <span class="comment">//                 continue;</span>
    <span class="comment">//             }</span>
    <span class="comment">//             m = result.unwrap();</span>
    <span class="comment">//         }</span>
    <span class="comment">//         if params.len() &gt; 300 {</span>
    <span class="comment">//             let mc = m.clone();</span>
    <span class="comment">//             for p in params.iter() {</span>
    <span class="comment">//                 if mc.contains_key(p.name.as_str()) {</span>
    <span class="comment">//                     print!(&quot;\&quot;{}\&quot;: {:?}, &quot;, p.name.as_str(), mc[p.name.as_str()]);</span>
    <span class="comment">//                 }</span>
    <span class="comment">//             }</span>
    <span class="comment">//             println!(&quot;&quot;);</span>
    <span class="comment">//         }</span>
    <span class="comment">//         let sub_res = self.propagate_re(index + 1, &amp;m, params, return_var)?;</span>
    <span class="comment">//         for ssr in sub_res {</span>
    <span class="comment">//             let mut m_copied = m.clone();</span>
    <span class="comment">//             let suc = Self::intersect_with(&amp;mut m_copied, &amp;ssr);</span>
    <span class="comment">//             if suc {</span>
    <span class="comment">//                 ret.push(m_copied);</span>
    <span class="comment">//             }</span>
    <span class="comment">//         }</span>
    <span class="comment">//     }</span>
    <span class="comment">//</span>
    <span class="comment">//     Ok(ret)</span>
    <span class="comment">// }</span>
    <span class="comment">//</span>
    <span class="comment">// /// Perform regulated DFS given f the starting node, and m the constraint map</span>
    <span class="comment">// pub fn propagate_dfs(</span>
    <span class="comment">//     &amp;self,</span>
    <span class="comment">//     f: NodeIndex,</span>
    <span class="comment">//     mut m: BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;,</span>
    <span class="comment">//     mut v_node: HashMap&lt;&amp;&#39;a str, i8&gt;,</span>
    <span class="comment">//     v_inst: HashMap&lt;i32, i32&gt;,</span>
    <span class="comment">//     m_constraits: &amp;BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;,</span>
    <span class="comment">//     mut debug_chain: std::vec::Vec&lt;(&amp;&#39;a str, i8)&gt;,</span>
    <span class="comment">//     verbose: bool,</span>
    <span class="comment">// ) -&gt; Result&lt;Option&lt;BTreeMap&lt;&amp;&#39;a str, BTreeSet&lt;i8&gt;&gt;&gt;, Box&lt;dyn Error&gt;&gt; {</span>
    <span class="comment">//     let w = self.graph.node_weight(f).unwrap();</span>
    <span class="comment">//     if (verbose &amp;&amp; debug_chain.len() &lt; 500) {</span>
    <span class="comment">//         let indent = (0..debug_chain.len() / 4).map(|_| &quot; &quot;).collect::&lt;String&gt;();</span>
    <span class="comment">//         println!(</span>
    <span class="comment">//             &quot;{}{}dfs({}, {}), m.len() = {}, v.len() = ({}, {}), visited.len() = {}&quot;,</span>
    <span class="comment">//             debug_chain.len(),</span>
    <span class="comment">//             indent,</span>
    <span class="comment">//             w.0,</span>
    <span class="comment">//             w.1,</span>
    <span class="comment">//             m.len(),</span>
    <span class="comment">//             v_node.len(),</span>
    <span class="comment">//             v_inst.len(),</span>
    <span class="comment">//             self.visited.borrow().len(),</span>
    <span class="comment">//         );</span>
    <span class="comment">//     }</span>
    <span class="comment">//     if self.visited.borrow().len() &gt;= DFS_RETURN_THRESHOLD {</span>
    <span class="comment">//         return Ok(Some(m));</span>
    <span class="comment">//     }</span>
    <span class="comment">//</span>
    <span class="comment">//     // NOTE: add the current node to v_node</span>
    <span class="comment">//     if v_node.contains_key(w.0) {</span>
    <span class="comment">//         return Err(Box::new(AlreadyVisitedIncompatible(format!(</span>
    <span class="comment">//             &quot;Visiting a node that&#39;s already visited... ({}, {}) | ({}, {})&quot;,</span>
    <span class="comment">//             w.0, w.1, w.0, v_node[w.0]</span>
    <span class="comment">//         ))));</span>
    <span class="comment">//     } else {</span>
    <span class="comment">//         v_node.insert(w.0, w.1);</span>
    <span class="comment">//     }</span>
    <span class="comment">//</span>
    <span class="comment">//     // NOTE: add the current split to m</span>
    <span class="comment">//     if m.contains_key(w.0) {</span>
    <span class="comment">//         m.get_mut(w.0).unwrap().insert(w.1);</span>
    <span class="comment">//         // m[w.0].insert(w.1);</span>
    <span class="comment">//     }</span>
    <span class="comment">//     m.insert(w.0, [w.1].iter().cloned().collect());</span>
    <span class="comment">//</span>
    <span class="comment">//     if self.visited.borrow().contains(&amp;m) {</span>
    <span class="comment">//         debug!(&quot;visited! visit len() = {}&quot;, self.visited.borrow().len());</span>
    <span class="comment">//         return Ok(None);</span>
    <span class="comment">//     }</span>
    <span class="comment">//     self.visited.borrow_mut().insert(m.clone());</span>
    <span class="comment">//</span>
    <span class="comment">//     // DEBUG: add node to debug_chain</span>
    <span class="comment">//     debug_chain.push((w.0, w.1));</span>
    <span class="comment">//</span>
    <span class="comment">//     // NOTE: process out edges</span>
    <span class="comment">//     let next_edges = self.graph.edges(f);</span>
    <span class="comment">//     let mut suc_once = -1i8;</span>
    <span class="comment">//     // let mut sub_results: HashMap&lt;&amp;&#39;a str, HashSet&lt;i8&gt;&gt; = HashMap::new();</span>
    <span class="comment">//     for e in next_edges {</span>
    <span class="comment">//         let ew = e.weight();</span>
    <span class="comment">//         // NOTE: check if we&#39;ve walked this instruction, but not this color</span>
    <span class="comment">//         // if so, we skip this edge due to color mismatch</span>
    <span class="comment">//         {</span>
    <span class="comment">//             let mut valid_edge = true;</span>
    <span class="comment">//             for (i, c) in ew {</span>
    <span class="comment">//                 if v_inst.contains_key(i) &amp;&amp; v_inst[i] != *c {</span>
    <span class="comment">//                     valid_edge = false;</span>
    <span class="comment">//                 }</span>
    <span class="comment">//             }</span>
    <span class="comment">//             if !valid_edge {</span>
    <span class="comment">//                 debug!(&quot;dfs({}, {}), abandoning edge {:?}&quot;, w.0, w.1, e.id(),);</span>
    <span class="comment">//                 continue;</span>
    <span class="comment">//             }</span>
    <span class="comment">//         }</span>
    <span class="comment">//</span>
    <span class="comment">//         let edge_endpoints = self.graph.edge_endpoints(e.id()).unwrap();</span>
    <span class="comment">//         let next_node = if edge_endpoints.0 == f {</span>
    <span class="comment">//             edge_endpoints.1</span>
    <span class="comment">//         } else {</span>
    <span class="comment">//             edge_endpoints.0</span>
    <span class="comment">//         };</span>
    <span class="comment">//         // NOTE: check if we&#39;ve visited other dimensions of the same node</span>
    <span class="comment">//         let nw = self.graph.node_weight(next_node).unwrap();</span>
    <span class="comment">//         if v_node.contains_key(nw.0) {</span>
    <span class="comment">//             continue;</span>
    <span class="comment">//         }</span>
    <span class="comment">//</span>
    <span class="comment">//         // NOTE: check if node is within constraint</span>
    <span class="comment">//         if m_constraits.contains_key(nw.0) &amp;&amp; !m_constraits[nw.0].contains(&amp;nw.1) {</span>
    <span class="comment">//             continue;</span>
    <span class="comment">//         }</span>
    <span class="comment">//</span>
    <span class="comment">//         // NOTE: add current edge to v_inst,</span>
    <span class="comment">//         // because we won&#39;t be able to see it in subroutines</span>
    <span class="comment">//         let mut v_inst_copied = v_inst.clone();</span>
    <span class="comment">//         for (i, c) in ew {</span>
    <span class="comment">//             if v_inst.contains_key(i) {</span>
    <span class="comment">//                 // println!(&quot;v_inst check {} vs {}&quot;, v_inst[i], c);</span>
    <span class="comment">//                 assert_eq!(v_inst[i] == *c, true);</span>
    <span class="comment">//             } else {</span>
    <span class="comment">//                 v_inst_copied.insert(*i, *c);</span>
    <span class="comment">//             }</span>
    <span class="comment">//         }</span>
    <span class="comment">//</span>
    <span class="comment">//         let new_map = self.propagate_dfs(</span>
    <span class="comment">//             next_node,</span>
    <span class="comment">//             m.clone(),</span>
    <span class="comment">//             v_node.clone(),</span>
    <span class="comment">//             v_inst_copied,</span>
    <span class="comment">//             m_constraits,</span>
    <span class="comment">//             debug_chain.clone(),</span>
    <span class="comment">//             verbose,</span>
    <span class="comment">//         )?;</span>
    <span class="comment">//</span>
    <span class="comment">//         // error handling, suc flag switching</span>
    <span class="comment">//         if new_map.is_none() {</span>
    <span class="comment">//             if suc_once == -1 {</span>
    <span class="comment">//                 suc_once = 0;</span>
    <span class="comment">//             }</span>
    <span class="comment">//             continue;</span>
    <span class="comment">//         }</span>
    <span class="comment">//         suc_once = 1;</span>
    <span class="comment">//         Self::merge_with(&amp;mut m, &amp;new_map.unwrap());</span>
    <span class="comment">//     }</span>
    <span class="comment">//     // Self::merge_with(&amp;mut m, sub_results);</span>
    <span class="comment">//     // println!(&quot;printing m before return&quot;);</span>
    <span class="comment">//     // for (k, v) in m.iter() {</span>
    <span class="comment">//     // 	println!(&quot;{} -&gt; {:?}&quot;, k, v);</span>
    <span class="comment">//     // }</span>
    <span class="comment">//     if suc_once == 0 {</span>
    <span class="comment">//         Ok(None)</span>
    <span class="comment">//     } else {</span>
    <span class="comment">//         Ok(Some(m))</span>
    <span class="comment">//     }</span>
    <span class="comment">// }</span>

    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">propagate_bsids</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">f</span>: <span class="ident">NodeIndex</span>,
        <span class="ident">m_constraints</span>: <span class="kw-2">&amp;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">verbose</span>: <span class="ident">bool</span>,
    ) {
        <span class="comment">// IDS globals</span>
        <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_mut</span>)]</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">m</span>: <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">BTreeMap</span>::<span class="ident">new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">q</span>: <span class="ident">VecDeque</span><span class="op">&lt;</span><span class="ident">State</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">VecDeque</span>::<span class="ident">new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v</span>: <span class="ident">HashSet</span><span class="op">&lt;</span><span class="ident">NodeType</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">HashSet</span>::<span class="ident">new</span>();

        <span class="comment">// first node</span>
        <span class="kw">let</span> <span class="ident">w</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">f</span>).<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">cur_state</span> <span class="op">=</span> <span class="ident">State</span>::<span class="ident">from_node</span>(<span class="ident">w</span>.<span class="number">0</span>, <span class="ident">w</span>.<span class="number">1</span>, <span class="ident">f</span>);
        <span class="ident">v</span>.<span class="ident">insert</span>(<span class="kw-2">*</span><span class="ident">w</span>);
        <span class="ident">q</span>.<span class="ident">push_back</span>(<span class="ident">cur_state</span>);

        <span class="comment">// search</span>
        <span class="kw">while</span> <span class="op">!</span><span class="ident">q</span>.<span class="ident">is_empty</span>() {
            <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="ident">q</span>.<span class="ident">pop_front</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">cn</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">s</span>.<span class="ident">last_node</span>).<span class="ident">unwrap</span>();
            <span class="ident">v</span>.<span class="ident">insert</span>((<span class="ident">cn</span>.<span class="number">0</span>, <span class="ident">cn</span>.<span class="number">1</span>));
        }

        <span class="macro">unimplemented</span><span class="macro">!</span>()
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">propagate_bfs</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">f</span>: <span class="ident">NodeIndex</span>,
        <span class="ident">m_constraits</span>: <span class="kw-2">&amp;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>,
        <span class="ident">verbose</span>: <span class="ident">bool</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span>, <span class="ident">Box</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Error</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="comment">// State: 1. All Visited Nodes, 2. Last Visited Node, 3. Visited Inst and Color</span>
        <span class="comment">//type State&lt;&#39;a&gt; = (BTreeMap&lt;&amp;&#39;a str, i8&gt;, &amp;&#39;a str, BTreeMap&lt;i32, i32&gt;);</span>

        <span class="comment">// bfs globals</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">m</span>: <span class="ident">BTreeMap</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">i8</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">BTreeMap</span>::<span class="ident">new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">q</span>: <span class="ident">VecDeque</span><span class="op">&lt;</span><span class="ident">State</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">VecDeque</span>::<span class="ident">new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v</span>: <span class="ident">HashSet</span><span class="op">&lt;</span><span class="ident">State</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">HashSet</span>::<span class="ident">new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">v_node</span>: <span class="ident">HashSet</span><span class="op">&lt;</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">str</span>, <span class="ident">i8</span>)<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">HashSet</span>::<span class="ident">new</span>();
        <span class="comment">// NOTE: could change one of the above to be references, saves 1/2 space</span>

        <span class="comment">// first node</span>
        <span class="kw">let</span> <span class="ident">w</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">f</span>).<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">cur_state</span> <span class="op">=</span> <span class="ident">State</span>::<span class="ident">from_node</span>(<span class="ident">w</span>.<span class="number">0</span>, <span class="ident">w</span>.<span class="number">1</span>, <span class="ident">f</span>);
        <span class="ident">v</span>.<span class="ident">insert</span>(<span class="ident">cur_state</span>.<span class="ident">clone</span>());
        <span class="ident">q</span>.<span class="ident">push_back</span>(<span class="ident">cur_state</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">max_depth</span> <span class="op">=</span> <span class="number">1</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">iter</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">while</span> <span class="op">!</span><span class="ident">q</span>.<span class="ident">is_empty</span>() {
            <span class="kw">let</span> <span class="ident">s</span> <span class="op">=</span> <span class="ident">q</span>.<span class="ident">pop_front</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">cn</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">s</span>.<span class="ident">last_node</span>).<span class="ident">unwrap</span>();
            <span class="ident">v_node</span>.<span class="ident">insert</span>((<span class="ident">cn</span>.<span class="number">0</span>, <span class="ident">cn</span>.<span class="number">1</span>));
            <span class="ident">iter</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            <span class="kw">if</span> <span class="ident">verbose</span> {
                <span class="kw">let</span> <span class="ident">cur_depth</span> <span class="op">=</span> <span class="ident">v_node</span>.<span class="ident">len</span>();
                <span class="kw">if</span> <span class="ident">cur_depth</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">max_depth</span> {
                    <span class="ident">max_depth</span> <span class="op">=</span> <span class="ident">cur_depth</span>;
                    <span class="macro">println</span><span class="macro">!</span>(
                        <span class="string">&quot;bfs({}, {}) L{}, v_node: {}, q: {}&quot;</span>,
                        <span class="ident">w</span>.<span class="number">0</span>,
                        <span class="ident">w</span>.<span class="number">1</span>,
                        <span class="ident">cur_depth</span>,
                        <span class="ident">v_node</span>.<span class="ident">len</span>(),
                        <span class="ident">q</span>.<span class="ident">len</span>(),
                    );
                } <span class="kw">else</span> {
                    <span class="comment">// if iter % 100 == 0 {</span>
                    <span class="comment">//     print!(&quot;.&quot;);</span>
                    <span class="comment">//     io::stdout().flush();</span>
                    <span class="comment">// }</span>
                }
            }

            <span class="comment">// add cn to m</span>
            <span class="kw">if</span> <span class="ident">m</span>.<span class="ident">contains_key</span>(<span class="ident">cn</span>.<span class="number">0</span>) {
                <span class="ident">m</span>.<span class="ident">get_mut</span>(<span class="ident">cn</span>.<span class="number">0</span>).<span class="ident">unwrap</span>().<span class="ident">insert</span>(<span class="ident">cn</span>.<span class="number">1</span>);
            } <span class="kw">else</span> {
                <span class="ident">m</span>.<span class="ident">insert</span>(<span class="ident">cn</span>.<span class="number">0</span>, [<span class="ident">cn</span>.<span class="number">1</span>].<span class="ident">iter</span>().<span class="ident">cloned</span>().<span class="ident">collect</span>());
            }

            <span class="kw">let</span> <span class="ident">next_edges</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">edges</span>(<span class="ident">s</span>.<span class="ident">last_node</span>);
            <span class="kw">for</span> <span class="ident">e</span> <span class="kw">in</span> <span class="ident">next_edges</span> {
                <span class="kw">let</span> <span class="ident">ew</span> <span class="op">=</span> <span class="ident">e</span>.<span class="ident">weight</span>();
                <span class="comment">// NOTE: check if we&#39;ve walked this inst, but with different color</span>
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">valid_edge</span> <span class="op">=</span> <span class="bool-val">true</span>;
                <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">c</span>) <span class="kw">in</span> <span class="ident">ew</span> {
                    <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">visited_inst</span>.<span class="ident">contains_key</span>(<span class="ident">i</span>) <span class="op">&amp;&amp;</span> <span class="ident">s</span>.<span class="ident">visited_inst</span>[<span class="ident">i</span>] <span class="op">!</span><span class="op">=</span> <span class="kw-2">*</span><span class="ident">c</span> {
                        <span class="ident">valid_edge</span> <span class="op">=</span> <span class="bool-val">false</span>;
                    }
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">color_connect</span>.<span class="ident">contains_key</span>(<span class="ident">c</span>) {
                        <span class="kw">let</span> <span class="ident">same_color_nodes</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">color_connect</span>[<span class="ident">c</span>].<span class="ident">clone</span>();
                        <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">same_color_nodes</span> {
                            <span class="kw">let</span> <span class="ident">xw</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">x</span>).<span class="ident">unwrap</span>();
                            <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">visited_node</span>.<span class="ident">contains_key</span>(<span class="ident">xw</span>.<span class="number">0</span>) <span class="op">&amp;&amp;</span> <span class="ident">s</span>.<span class="ident">visited_node</span>[<span class="ident">xw</span>.<span class="number">0</span>] <span class="op">!</span><span class="op">=</span> <span class="ident">xw</span>.<span class="number">1</span> {
                                <span class="ident">valid_edge</span> <span class="op">=</span> <span class="bool-val">false</span>;
                            }
                            <span class="kw">if</span> <span class="ident">m_constraits</span>.<span class="ident">contains_key</span>(<span class="ident">xw</span>.<span class="number">0</span>)
                                <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">m_constraits</span>[<span class="ident">xw</span>.<span class="number">0</span>].<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">xw</span>.<span class="number">1</span>)
                            {
                                <span class="ident">valid_edge</span> <span class="op">=</span> <span class="bool-val">false</span>;
                            }
                        }
                    }
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">color_cover</span>.<span class="ident">contains_key</span>(<span class="ident">c</span>) {
                        <span class="kw">let</span> <span class="ident">same_color_edges</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">color_cover</span>[<span class="ident">c</span>].<span class="ident">clone</span>();
                        <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">same_color_edges</span> {
                            <span class="kw">let</span> <span class="ident">xw</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">edge_weight</span>(<span class="ident">x</span>).<span class="ident">unwrap</span>();
                            <span class="kw">for</span> (<span class="ident">xi</span>, <span class="ident">xc</span>) <span class="kw">in</span> <span class="ident">xw</span> {
                                <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">visited_inst</span>.<span class="ident">contains_key</span>(<span class="ident">xi</span>) <span class="op">&amp;&amp;</span> <span class="ident">s</span>.<span class="ident">visited_inst</span>[<span class="ident">xi</span>] <span class="op">!</span><span class="op">=</span> <span class="kw-2">*</span><span class="ident">xc</span> {
                                    <span class="ident">valid_edge</span> <span class="op">=</span> <span class="bool-val">false</span>;
                                }
                            }
                        }
                    }
                }
                <span class="kw">if</span> <span class="op">!</span><span class="ident">valid_edge</span> {
                    <span class="macro">debug</span><span class="macro">!</span>(<span class="string">&quot;bfs({}, {}), abandoning edge {:?}&quot;</span>, <span class="ident">cn</span>.<span class="number">0</span>, <span class="ident">cn</span>.<span class="number">1</span>, <span class="ident">e</span>.<span class="ident">id</span>());
                    <span class="kw">continue</span>;
                }

                <span class="comment">// NOTE: get next node</span>
                <span class="kw">let</span> <span class="ident">edge_endpoints</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">edge_endpoints</span>(<span class="ident">e</span>.<span class="ident">id</span>()).<span class="ident">unwrap</span>();
                <span class="kw">let</span> <span class="ident">next_node</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">edge_endpoints</span>.<span class="number">0</span> <span class="op">=</span><span class="op">=</span> <span class="ident">s</span>.<span class="ident">last_node</span> {
                    <span class="ident">edge_endpoints</span>.<span class="number">1</span>
                } <span class="kw">else</span> {
                    <span class="ident">edge_endpoints</span>.<span class="number">0</span>
                };
                <span class="kw">let</span> <span class="ident">nw</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">next_node</span>).<span class="ident">unwrap</span>();

                <span class="kw">if</span> <span class="ident">v_node</span>.<span class="ident">contains</span>(<span class="ident">nw</span>) {
                    <span class="kw">continue</span>;
                }

                <span class="comment">// NOTE: check if we&#39;ve visited other dimensions of this node</span>
                <span class="kw">if</span> <span class="ident">s</span>.<span class="ident">visited_node</span>.<span class="ident">contains_key</span>(<span class="ident">nw</span>.<span class="number">0</span>) {
                    <span class="kw">continue</span>;
                }

                <span class="comment">// NOTE: check if node is within constraints</span>
                <span class="kw">if</span> <span class="ident">m_constraits</span>.<span class="ident">contains_key</span>(<span class="ident">nw</span>.<span class="number">0</span>) <span class="op">&amp;&amp;</span> <span class="op">!</span><span class="ident">m_constraits</span>[<span class="ident">nw</span>.<span class="number">0</span>].<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">nw</span>.<span class="number">1</span>) {
                    <span class="kw">continue</span>;
                }

                <span class="comment">// NOTE: add current edge to v_inst,</span>

                <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">c</span>) <span class="kw">in</span> <span class="ident">ew</span> {
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">next_state</span> <span class="op">=</span> <span class="ident">s</span>.<span class="ident">clone</span>();
                    <span class="ident">next_state</span>.<span class="ident">add_edge</span>(<span class="kw-2">*</span><span class="ident">i</span>, <span class="kw-2">*</span><span class="ident">c</span>);
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">color_connect</span>.<span class="ident">contains_key</span>(<span class="ident">c</span>) {
                        <span class="kw">let</span> <span class="ident">same_color_nodes</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">color_connect</span>[<span class="ident">c</span>].<span class="ident">clone</span>();
                        <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">same_color_nodes</span> {
                            <span class="kw">let</span> <span class="ident">xw</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">node_weight</span>(<span class="ident">x</span>).<span class="ident">unwrap</span>();
                            <span class="ident">next_state</span>.<span class="ident">visited_node</span>.<span class="ident">insert</span>(<span class="ident">xw</span>.<span class="number">0</span>, <span class="ident">xw</span>.<span class="number">1</span>);
                        }
                    }
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">color_cover</span>.<span class="ident">contains_key</span>(<span class="ident">c</span>) {
                        <span class="kw">let</span> <span class="ident">same_color_edges</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">color_cover</span>[<span class="ident">c</span>].<span class="ident">clone</span>();
                        <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">same_color_edges</span> {
                            <span class="kw">let</span> <span class="ident">xw</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">graph</span>.<span class="ident">edge_weight</span>(<span class="ident">x</span>).<span class="ident">unwrap</span>();
                            <span class="kw">for</span> (<span class="ident">xi</span>, <span class="ident">xc</span>) <span class="kw">in</span> <span class="ident">xw</span> {
                                <span class="ident">next_state</span>.<span class="ident">visited_inst</span>.<span class="ident">insert</span>(<span class="kw-2">*</span><span class="ident">xi</span>, <span class="kw-2">*</span><span class="ident">xc</span>);
                            }
                        }
                    }
                    <span class="ident">next_state</span>.<span class="ident">add_node</span>(<span class="ident">nw</span>.<span class="number">0</span>, <span class="ident">nw</span>.<span class="number">1</span>, <span class="ident">next_node</span>);
                    <span class="kw">if</span> <span class="op">!</span><span class="ident">v</span>.<span class="ident">contains</span>(<span class="kw-2">&amp;</span><span class="ident">next_state</span>) {
                        <span class="ident">v</span>.<span class="ident">insert</span>(<span class="ident">next_state</span>.<span class="ident">clone</span>());
                        <span class="ident">q</span>.<span class="ident">push_back</span>(<span class="ident">next_state</span>);
                    } <span class="kw">else</span> {
                        <span class="macro">debug</span><span class="macro">!</span>(
                            <span class="string">&quot;bfs({}, {} | L{}) state visited: {:?}&quot;</span>,
                            <span class="ident">w</span>.<span class="number">0</span>,
                            <span class="ident">w</span>.<span class="number">1</span>,
                            <span class="ident">next_state</span>.<span class="ident">visited_node</span>.<span class="ident">len</span>(),
                            <span class="ident">next_state</span>.<span class="ident">last_node</span>
                        );
                    }
                }
            } <span class="comment">// end for e in next_edges</span>
        }

        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">m</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>